% Talk with RSCAD with 'ListenOnPort' capability
% This M file should be on the same directory as the 'jtcp.m' file.
% This M file is illustrative purpose only.
% pik-2012.03.05

clear;
clc;
portnum = 4575;
expr2 = 'VALOUT\s*=\s*(?<var_value1>(-)?\d+(.\d+)?)\s*END';

% Runtime is acting as TCP socket server
JTCPOBJ = jtcp('REQUEST','127.0.0.1', portnum);
%JTCPOBJ = jtcp('REQUEST','192.168.5.160',4575);

t = cputime;
jtcp('writes',JTCPOBJ,'Start;');
for i=1:100
    
    disp(' ');
    
    msg2 = sprintf('Iteration number: %d', i);
    disp(msg2);
    
    msg2 = sprintf('SetSlider "Subsystem #1 : CTLs : Inputs : VAL" = %f;', i);
    jtcp('writes', JTCPOBJ, msg2);
    
    jtcp('writes',JTCPOBJ,'SUSPEND 0.2;');
    
    % Capture meter value
    
    jtcp('writes',JTCPOBJ,'temp_float = MeterCapture("VALOUT");');
    jtcp('writes',JTCPOBJ,'sprintf(temp_string, "VALOUT = %f END", temp_float);');
    jtcp('writes',JTCPOBJ,'ListenOnPortHandshake(temp_string);');
    
    rmsg = [];
    rmsg2 = 'dummy';
    
    while (isempty(regexp(rmsg2, expr2)) == 1)
        
        rmsg = [rmsg jtcp('read',JTCPOBJ)];
        rmsg2 = char(rmsg);
        
        if(regexp(rmsg2, expr2))
            
            [tokens value] = regexp(rmsg2, expr2, 'tokens', 'names');
            
            fTemp2 = str2num(value.var_value1);
            
            msg2 = sprintf('Value returned: %f', fTemp2);
            disp(msg2);
            
            break;
        else
            continue;
        end
    end
    
end

jtcp('writes',JTCPOBJ,'stop;');
msg2 = sprintf('ClosePort(%d);', portnum);
jtcp('writes',JTCPOBJ,msg2);

disp('Iteration finished.');

e = cputime-t;
msg2 = sprintf('Total execution time: %f', e);
disp(msg2);





