# -*- coding: utf-8 -*-
"""
Created on Fri Sep 01 12:14:40 2017

@author: Christian Jegues

For use with Pingpong sample case in RSCAD

"""

import socket
import time


TCP_IP = '127.0.0.1'
TCP_PORT = 4575
BUFFER_SIZE = 1024

s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
s.connect((TCP_IP, TCP_PORT))

start = time.clock()
for i in range(1,101):
    print ('Iteration number: %d' % (i))
    s.send('SetSlider "Subsystem #1 : CTLs : Inputs : VAL" = %f;' % (i))
    s.send('SUSPEND 0.2;')
    s.send('temp_float = MeterCapture("VALOUT");')
    s.send('sprintf(temp_string, "VALOUT = %f END", temp_float);')
    s.send('ListenOnPortHandshake(temp_string);')
    tokenstring = s.recv(BUFFER_SIZE)
    print ("The token string returned is: ", tokenstring)
    
s.send('Stop;')
time.sleep(1)   #This sleep is needed for the ClosePort() below
s.send('ClosePort(%d);' % (TCP_PORT))
s.close()

print ('All iterations complete.')
finish = time.clock() - start
print ('The execution time is %fs.' %finish)
